# Game of life

simple c implementation of [Conway's game of life](https://en.wikipedia.org/wiki/Conway%27s_Game_of_Life).

## usage

- download /clone the src folder.
- use the folling template: 

```c
#include "gol.h"
#include <stdio.h>
const unsigned int ROUNDS = 2;

//for each colmn print the value
void print_colmn(unsigned int value)
{
	printf("%d", value);
}

//print each row
void print_row(unsigned int line)
{
	printf("\n");
}

int main(int argc, char **argv)
{
	//setup a game of life struct with (24*5 cells)
	gol *game = gol_setup(3, 5);
	//set dead/alive cells
	game->current[7] = 28; // set ---  (blinker)
	unsigned int round = 0;
	while (1)
	{
		printf("round: %d \n", round++);
		//print current fields
		gol_each(game, &print_colmn, &print_row);
		if (round > ROUNDS)
		{
			break;
		}
		//evolve one time step
		gol_tick(game);
	}
	//free everything
	gol_free(game);
}
```

## test

```bash
make test
echo $?
```